# w.c.s. - web application for online forms
# Copyright (C) 2005-2010  Entr'ouvert
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301  USA

import schema
import form

class SchemaForm(object):
    '''Create and parse forms for a configuration schema'''
    schema = None

    _widget_class_map = {
            schema.Boolean: form.CheckboxWidget,
            }


    def __init__(self, schema):
        self.schema = schema

    def _getLeafWidget(self, form, prefix, schema, value):
        widget_class = self._widget_class_map.get(schema.__class__)
        if widget_class:
            if not schema.check(value):
                # FIXME: emit a warning
                value = schema.default
            return widget_class(prefix + schema.name, required=True, title = _(schema.title), hint = _(self.description), value = value)
        raise NotImplementedError('%s is not supported by %s' % (schema.__class__, self.__class__))

    def getForm(self,value,path=None):
        '''Get a form for current schema and eventually a path'''
        raise NotImplementedError()

    def parseForm(self,form,path=None):
        '''Get a form for current schema and eventually a path'''
        raise NotImplementedError()
